diff --git a/lib/librte_vhost/rte_vdpa.h b/lib/librte_vhost/rte_vdpa.h
index 5065e2130e..f074ec0c4a 100644
--- a/lib/librte_vhost/rte_vdpa.h
+++ b/lib/librte_vhost/rte_vdpa.h
@@ -42,9 +42,6 @@ struct rte_vdpa_stat_name {
 };
 
 /**
- * @warning
- * @b EXPERIMENTAL: this API may change without prior notice
- *
  * Find the device id of a vdpa device from its name
  *
  * @param name
@@ -52,14 +49,10 @@ struct rte_vdpa_stat_name {
  * @return
  *  vDPA device pointer on success, NULL on failure
  */
-__rte_experimental
 struct rte_vdpa_device *
 rte_vdpa_find_device_by_name(const char *name);
 
 /**
- * @warning
- * @b EXPERIMENTAL: this API may change without prior notice
- *
  * Get the generic device from the vdpa device
  *
  * @param vdpa_dev
@@ -67,14 +60,10 @@ rte_vdpa_find_device_by_name(const char *name);
  * @return
  *  generic device pointer on success, NULL on failure
  */
-__rte_experimental
 struct rte_device *
 rte_vdpa_get_rte_device(struct rte_vdpa_device *vdpa_dev);
 
 /**
- * @warning
- * @b EXPERIMENTAL: this API may change without prior notice
- *
  * Get number of queue pairs supported by the vDPA device
  *
  * @param dev
@@ -84,14 +73,10 @@ rte_vdpa_get_rte_device(struct rte_vdpa_device *vdpa_dev);
  * @return
  *  0 on success, -1 on failure
  */
-__rte_experimental
 int
 rte_vdpa_get_queue_num(struct rte_vdpa_device *dev, uint32_t *queue_num);
 
 /**
- * @warning
- * @b EXPERIMENTAL: this API may change without prior notice
- *
  * Get the Virtio features supported by the vDPA device
  *
  * @param dev
@@ -101,14 +86,10 @@ rte_vdpa_get_queue_num(struct rte_vdpa_device *dev, uint32_t *queue_num);
  * @return
  *  0 on success, -1 on failure
  */
-__rte_experimental
 int
 rte_vdpa_get_features(struct rte_vdpa_device *dev, uint64_t *features);
 
 /**
- * @warning
- * @b EXPERIMENTAL: this API may change without prior notice
- *
  * Get the Vhost-user protocol features supported by the vDPA device
  *
  * @param dev
@@ -118,14 +99,10 @@ rte_vdpa_get_features(struct rte_vdpa_device *dev, uint64_t *features);
  * @return
  *  0 on success, -1 on failure
  */
-__rte_experimental
 int
 rte_vdpa_get_protocol_features(struct rte_vdpa_device *dev, uint64_t *features);
 
 /**
- * @warning
- * @b EXPERIMENTAL: this API may change without prior notice
- *
  * Synchronize the used ring from mediated ring to guest, log dirty
  * page for each writeable buffer, caller should handle the used
  * ring logging before device stop.
@@ -139,14 +116,10 @@ rte_vdpa_get_protocol_features(struct rte_vdpa_device *dev, uint64_t *features);
  * @return
  *  number of synced used entries on success, -1 on failure
  */
-__rte_experimental
 int
 rte_vdpa_relay_vring_used(int vid, uint16_t qid, void *vring_m);
 
 /**
- * @warning
- * @b EXPERIMENTAL: this API may change without prior notice
- *
  * Retrieve names of statistics of a vDPA device.
  *
  * There is an assumption that 'stat_names' and 'stats' arrays are matched
@@ -166,16 +139,12 @@ rte_vdpa_relay_vring_used(int vid, uint16_t qid, void *vring_m);
  *   A negative value on error, otherwise the number of entries filled in the
  *   stats name array.
  */
-__rte_experimental
 int
 rte_vdpa_get_stats_names(struct rte_vdpa_device *dev,
 		struct rte_vdpa_stat_name *stats_names,
 		unsigned int size);
 
 /**
- * @warning
- * @b EXPERIMENTAL: this API may change without prior notice
- *
  * Retrieve statistics of a vDPA device.
  *
  * There is an assumption that 'stat_names' and 'stats' arrays are matched
@@ -197,14 +166,10 @@ rte_vdpa_get_stats_names(struct rte_vdpa_device *dev,
  *   A negative value on error, otherwise the number of entries filled in the
  *   stats table.
  */
-__rte_experimental
 int
 rte_vdpa_get_stats(struct rte_vdpa_device *dev, uint16_t qid,
 		struct rte_vdpa_stat *stats, unsigned int n);
 /**
- * @warning
- * @b EXPERIMENTAL: this API may change without prior notice
- *
  * Reset statistics of a vDPA device.
  *
  * @param dev
@@ -214,7 +179,6 @@ rte_vdpa_get_stats(struct rte_vdpa_device *dev, uint16_t qid,
  * @return
  *   0 on success, a negative value on error.
  */
-__rte_experimental
 int
 rte_vdpa_reset_stats(struct rte_vdpa_device *dev, uint16_t qid);
 #endif /* _RTE_VDPA_H_ */
diff --git a/lib/librte_vhost/rte_vdpa_dev.h b/lib/librte_vhost/rte_vdpa_dev.h
index 89444c2ea1..a60183f780 100644
--- a/lib/librte_vhost/rte_vdpa_dev.h
+++ b/lib/librte_vhost/rte_vdpa_dev.h
@@ -78,9 +78,6 @@ struct rte_vdpa_device {
 };
 
 /**
- * @warning
- * @b EXPERIMENTAL: this API may change without prior notice
- *
  * Register a vdpa device
  *
  * @param rte_dev
@@ -90,15 +87,11 @@ struct rte_vdpa_device {
  * @return
  *  vDPA device pointer on success, NULL on failure
  */
-__rte_experimental
 struct rte_vdpa_device *
 rte_vdpa_register_device(struct rte_device *rte_dev,
 		struct rte_vdpa_dev_ops *ops);
 
 /**
- * @warning
- * @b EXPERIMENTAL: this API may change without prior notice
- *
  * Unregister a vdpa device
  *
  * @param dev
@@ -106,14 +99,10 @@ rte_vdpa_register_device(struct rte_device *rte_dev,
  * @return
  *  device id on success, -1 on failure
  */
-__rte_experimental
 int
 rte_vdpa_unregister_device(struct rte_vdpa_device *dev);
 
 /**
- * @warning
- * @b EXPERIMENTAL: this API may change without prior notice
- *
  * Enable/Disable host notifier mapping for a vdpa port.
  *
  * @param vid
@@ -125,14 +114,10 @@ rte_vdpa_unregister_device(struct rte_vdpa_device *dev);
  * @return
  *  0 on success, -1 on failure
  */
-__rte_experimental
 int
 rte_vhost_host_notifier_ctrl(int vid, uint16_t qid, bool enable);
 
 /**
- * @warning
- * @b EXPERIMENTAL: this API may change without prior notice
- *
  * Synchronize the used ring from mediated ring to guest, log dirty
  * page for each writeable buffer, caller should handle the used
  * ring logging before device stop.
@@ -146,7 +131,6 @@ rte_vhost_host_notifier_ctrl(int vid, uint16_t qid, bool enable);
  * @return
  *  number of synced used entries on success, -1 on failure
  */
-__rte_experimental
 int
 rte_vdpa_relay_vring_used(int vid, uint16_t qid, void *vring_m);
 
diff --git a/lib/librte_vhost/rte_vhost.h b/lib/librte_vhost/rte_vhost.h
index a94c84134d..883a334cb4 100644
--- a/lib/librte_vhost/rte_vhost.h
+++ b/lib/librte_vhost/rte_vhost.h
@@ -430,7 +430,6 @@ int rte_vhost_driver_unregister(const char *path);
  * @return
  *  0 on success, -1 on failure
  */
-__rte_experimental
 int
 rte_vhost_driver_attach_vdpa_device(const char *path,
 		struct rte_vdpa_device *dev);
@@ -443,7 +442,6 @@ rte_vhost_driver_attach_vdpa_device(const char *path,
  * @return
  *  0 on success, -1 on failure
  */
-__rte_experimental
 int
 rte_vhost_driver_detach_vdpa_device(const char *path);
 
@@ -455,7 +453,6 @@ rte_vhost_driver_detach_vdpa_device(const char *path);
  * @return
  *  vDPA device pointer, NULL on failure
  */
-__rte_experimental
 struct rte_vdpa_device *
 rte_vhost_driver_get_vdpa_device(const char *path);
 
@@ -913,7 +910,6 @@ uint32_t rte_vhost_rx_queue_count(int vid, uint16_t qid);
  * @return
  *  0 on success, -1 on failure
  */
-__rte_experimental
 int
 rte_vhost_get_log_base(int vid, uint64_t *log_base, uint64_t *log_size);
 
@@ -931,7 +927,6 @@ rte_vhost_get_log_base(int vid, uint64_t *log_base, uint64_t *log_size);
  * @return
  *  0 on success, -1 on failure
  */
-__rte_experimental
 int
 rte_vhost_get_vring_base(int vid, uint16_t queue_id,
 		uint16_t *last_avail_idx, uint16_t *last_used_idx);
@@ -973,7 +968,6 @@ rte_vhost_get_vring_base_from_inflight(int vid,
  * @return
  *  0 on success, -1 on failure
  */
-__rte_experimental
 int
 rte_vhost_set_vring_base(int vid, uint16_t queue_id,
 		uint16_t last_avail_idx, uint16_t last_used_idx);
diff --git a/lib/librte_vhost/rte_vhost_version.map b/lib/librte_vhost/rte_vhost_version.map
index 20b4abcb4e..55e98e557b 100644
--- a/lib/librte_vhost/rte_vhost_version.map
+++ b/lib/librte_vhost/rte_vhost_version.map
@@ -26,13 +26,10 @@ DPDK_21 {
 	rte_vhost_log_write;
 	rte_vhost_rx_queue_count;
 	rte_vhost_vring_call;
-
-	local: *;
-};
-
-EXPERIMENTAL {
-	global:
-
+	rte_vhost_get_log_base;
+	rte_vhost_get_vring_base;
+	rte_vhost_set_vring_base;
+	rte_vhost_host_notifier_ctrl;
 	rte_vdpa_register_device;
 	rte_vdpa_unregister_device;
 	rte_vdpa_get_stats_names;
@@ -42,19 +39,27 @@ EXPERIMENTAL {
 	rte_vhost_driver_detach_vdpa_device;
 	rte_vhost_driver_get_vdpa_device;
 	rte_vhost_get_vdpa_device;
+	rte_vdpa_find_device_by_name;
+	rte_vdpa_get_rte_device;
+	rte_vdpa_get_queue_num;
+	rte_vdpa_get_features;
+	rte_vdpa_get_protocol_features;
+	rte_vdpa_relay_vring_used;
+
+	local: *;
+};
+
+EXPERIMENTAL {
+	global:
+
 	rte_vhost_driver_get_protocol_features;
 	rte_vhost_driver_get_queue_num;
-	rte_vhost_get_log_base;
-	rte_vhost_get_vring_base;
-	rte_vhost_set_vring_base;
 	rte_vhost_crypto_create;
 	rte_vhost_crypto_free;
 	rte_vhost_crypto_fetch_requests;
 	rte_vhost_crypto_finalize_requests;
 	rte_vhost_crypto_set_zero_copy;
 	rte_vhost_va_from_guest_pa;
-	rte_vhost_host_notifier_ctrl;
-	rte_vdpa_relay_vring_used;
 	rte_vhost_extern_callback_register;
 	rte_vhost_driver_set_protocol_features;
 	rte_vhost_set_inflight_desc_split;
@@ -66,11 +71,6 @@ EXPERIMENTAL {
 	rte_vhost_get_vhost_ring_inflight;
 	rte_vhost_get_vring_base_from_inflight;
 	rte_vhost_slave_config_change;
-	rte_vdpa_find_device_by_name;
-	rte_vdpa_get_rte_device;
-	rte_vdpa_get_queue_num;
-	rte_vdpa_get_features;
-	rte_vdpa_get_protocol_features;
 	rte_vhost_async_channel_register;
 	rte_vhost_async_channel_unregister;
 	rte_vhost_submit_enqueue_burst;